------区间DP hdu 5115

来源:互联网 发布:数据库集群方案 编辑:程序博客网 时间:2024/05/29 09:22

Dire wolves, also known as Dark wolves, are extraordinarily large and powerful wolves. Many, if not all, Dire Wolves appear to originate from Draenor.
Dire wolves look like normal wolves, but these creatures are of nearly twice the size. These powerful beasts, 8 - 9 feet long and weighing 600 - 800 pounds, are the most well-known orc mounts. As tall as a man, these great wolves have long tusked jaws that look like they could snap an iron bar. They have burning red eyes. Dire wolves are mottled gray or black in color. Dire wolves thrive in the northern regions of Kalimdor and in Mulgore.
Dire wolves are efficient pack hunters that kill anything they catch. They prefer to attack in packs, surrounding and flanking a foe when they can.
— Wowpedia, Your wiki guide to the World of Warcra

Matt, an adventurer from the Eastern Kingdoms, meets a pack of dire wolves. There are N wolves standing in a row (numbered with 1 to N from left to right). Matt has to defeat all of them to survive.

Once Matt defeats a dire wolf, he will take some damage which is equal to the wolf’s current attack. As gregarious beasts, each dire wolf i can increase its adjacent wolves’ attack by b i. Thus, each dire wolf i’s current attack consists of two parts, its basic attack ai and the extra attack provided by the current adjacent wolves. The increase of attack is temporary. Once a wolf is defeated, its adjacent wolves will no longer get extra attack from it. However, these two wolves (if exist) will become adjacent to each other now.

For example, suppose there are 3 dire wolves standing in a row, whose basic attacks ai are (3, 5, 7), respectively. The extra attacks b i they can provide are (8, 2, 0). Thus, the current attacks of them are (5, 13, 9). If Matt defeats the second wolf first, he will get 13 points of damage and the alive wolves’ current attacks become (3, 15).

As an alert and resourceful adventurer, Matt can decide the order of the dire wolves he defeats. Therefore, he wants to know the least damage he has to take to defeat all the wolves.
Input
The first line contains only one integer T , which indicates the number of test cases. For each test case, the first line contains only one integer N (2 ≤ N ≤ 200).

The second line contains N integers a i (0 ≤ a i ≤ 100000), denoting the basic attack of each dire wolf.

The third line contains N integers b i (0 ≤ b i ≤ 50000), denoting the extra attack each dire wolf can provide.
Output
For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1), y is the least damage Matt needs to take.
Sample Input
2
3
3 5 7
8 2 0
10
1 3 5 7 9 2 4 6 8 10
9 4 1 2 1 2 1 4 5 1
Sample Output
Case #1: 17
Case #2: 74

Hint
In the first sample, Matt defeats the dire wolves from left to right. He takes 5 + 5 + 7 = 17 points of damage which is the least damage he has to take.

题目大意:
有一排狼,每只狼都有自己的基础攻击值和额外攻击值,当你去杀一头狼的时候,你会受到狼本身的基础攻击值,和它左右两边狼的额外攻击值,问你,当你把所有狼都杀完的时候,最小受到的攻击值是多少
解题思路:
根据题目给的样例会发现,只要求怎么使额外攻击值最小就行,其他攻击值是一定的,而且,先杀额外攻击值最大的,然后是杀两侧的,会使得额外攻击值最小
做法是区间DP:
dp[i][j]代表杀光区间i-j所有的狼,所受到的最小攻击值,k是区间i-j里面最后杀的那只狼
转移方程:
dp[i][j]=min(dp[i][j],dp[i][k-1]+dp[k+1][j]+a[k]+b[i-1]+b[j+1])///a[k]是基础攻击,b[i-1]是i-j区间的左边的值,b[j+1]是i-j区间的的右边的值,因为k是i-j区间最后杀的,也就是说i-j区间内只有它了,所以它左右紧凑过来的,应该是开始的时候区间i-j两边的值,也就是i-1和j+1

#include<cstdio>#include<cstring>#include<algorithm>#include<iostream>#include<cmath>using namespace std;const int INF=0x3f3f3f3f;int dp[210][210];///dp[i][j]代表全部杀光第i只狼到第j只狼所受到的最小攻击int a[210],b[210];///a是基本攻击,b是额外攻击int main(){    int t,cas,n;    scanf("%d",&t);    for(int cas=1;cas<=t;cas++)    {        scanf("%d",&n);        for(int i=1;i<=n;i++)            scanf("%d",&a[i]);        for(int j=1;j<=n;j++)            scanf("%d",&b[j]);        a[0]=b[0]=a[n+1]=b[n+1]=0;///初始化边界情况        memset(dp,INF,sizeof(dp));        for(int i=1;i<=n;i++)            dp[i][i]=a[i]+b[i-1]+b[i+1];///区间长度为1的时候的情况        for(int len=2;len<=n;len++)///枚举所有可能的区间长度        {            for(int i=1;i<=n-len+1;i++)///枚举所有可能的起点            {                int j=i+len-1;///j代表区间的右端点///即区间[i,j]                dp[i][j]=min(dp[i+1][j]+a[i]+b[i-1]+b[j+1],dp[i][j-1]+a[j]+b[i-1]+b[j+1]);///先考虑左右端点时候的特殊情况                for(int k=i+1;k<j;k++)///k是最后一只杀的狼                dp[i][j]=min(dp[i][j],dp[i][k-1]+dp[k+1][j]+a[k]+b[i-1]+b[j+1]);            }        }        printf("Case #%d: ",cas);        printf("%d\n",dp[1][n]);    }}
原创粉丝点击